using System;
using ProtoBuf;
using Fantasy;
using System.Linq;
using System.Reflection;
using System.Collections.Generic;
using System.Collections.Concurrent;
using Fantasy.Serialize;
using Fantasy.ConfigTable;

namespace NBF
{
    [ProtoContract]
    public sealed partial class ItemConfig : ASerialize, IProto, IConfigTable
    {
    
		[ProtoMember(1)]
		public uint Id { get; set; } // Id
		[ProtoMember(2)]
		public string Model { get; set; } // 模型
		[ProtoMember(3)]
		public uint Type { get; set; } // 类型
		[ProtoMember(4)]
		public uint Max { get; set; } // 最大堆叠数量
		[ProtoMember(5)]
		public uint AutoUse { get; set; } // 获得自动使用  
        [ProtoIgnore]
        public uint Key => Id;
        
        #region Static
        
        private static ConfigContext<ItemConfig> Context => ConfigTableHelper.Table<ItemConfig>();

        public static ItemConfig Get(uint key)
        {
            return Context.Get(key);
        }

        public static ItemConfig Get(Predicate<ItemConfig> match)
        {
            return Context.Get(match);
        }
        
        public static ItemConfig Fist()
        {
            return Context.Fist();
        }

        public static ItemConfig Last()
        {
            return Context.Last();
        }

        public static ItemConfig Fist(Predicate<ItemConfig> match)
        {
            return Context.Fist(match);
        }

        public static ItemConfig Last(Predicate<ItemConfig> match)
        {
            return Context.Last(match);
        }
        
        public static int Count()
        {
            return Context.Count();
        }

        public static int Count(Func<ItemConfig, bool> predicate)
        {
            return Context.Count(predicate);
        }

        public static List<ItemConfig> GetList()
        {
            return Context.GetList();
        }

        public static List<ItemConfig> GetList(Predicate<ItemConfig> match)
        {
            return Context.GetList(match);
        }
        public static void ParseJson(Newtonsoft.Json.Linq.JArray arr)
        {
            ConfigTableHelper.ParseLine<ItemConfig>(arr);
        }
        #endregion
    }
}